# Non-recursive prologue.
include $(Prologue)


VERSION_$(d)	:= 0.3	# libtool doesn't like the third [patch] component.


OBJS_$(d)	:= $(d)/bufio.o $(d)/bufio/membuf.o $(d)/bufio/pagebuf.o $(d)/bufio/socket.o $(d)/socket.o $(d)/thread.o $(d)/lookup.o $(d)/tls.o $(d)/bufio/pipe.o $(d)/bufio/drain.o $(d)/dns.o
SRCS_$(d)	:= $(d)/bufio.c $(d)/bufio/membuf.c $(d)/bufio/pagebuf.c $(d)/bufio/socket.c $(d)/socket.c $(d)/thread.c $(d)/lookup.c $(d)/tls.c $(d)/bufio/pipe.c $(d)/bufio/drain.c $(d)/dns.c
INCS_$(d)	:= $(d)/bufio.h $(d)/bufio/membuf.h $(d)/bufio/pagebuf.h $(d)/bufio/socket.h $(d)/socket.h $(d)/thread.h $(d)/lookup.h $(d)/tls.h $(d)/bufio/pipe.h $(d)/bufio/drain.h $(d)/dns.h


CFLAGS_$(d)	:= $(CFLAGS)
CPPFLAGS_$(d)	:= -DLIBEVNET_SOURCE -I$($(d)/..)/compat -I$($(d)/..)/compat/win32 -I$($(d)/..)/compat/bsd -I$(d) -I$(DESTDIR)$(includedir) $(CPPFLAGS)


#
# Compilation Targets
#
Build_$(d)	= $(CC) -c $(CPPFLAGS_$(@D)) $(CFLAGS_$(@D)) -o $@ $^ $>

$(d)/socket.o: $(d)/socket.c
	$(Build_$(@D))

$(d)/thread.o: $(d)/thread.c
	$(Build_$(@D))

$(d)/lookup.o: $(d)/lookup.c
	$(Build_$(@D))

$(d)/tls.o: $(d)/tls.c
	$(Build_$(@D))

$(d)/bufio.o: $(d)/bufio.c
	$(Build_$(@D))

$(d)/dns.o: $(d)/dns.c
	$(Build_$(@D)) -std=gnu99

CFLAGS_$(d)/bufio	:= $(CFLAGS_$(d))
CPPFLAGS_$(d)/bufio	:= $(CPPFLAGS_$(d))
Build_$(d)/bufio	= $(CC) -c $(CPPFLAGS_$(@D)) $(CFLAGS_$(@D)) -o $@ $^ $>

$(d)/bufio/membuf.o: $(d)/bufio/membuf.c
	$(Build_$(@D))

$(d)/bufio/pagebuf.o: $(d)/bufio/pagebuf.c
	$(Build_$(@D))

$(d)/bufio/socket.o: $(d)/bufio/socket.c
	$(Build_$(@D))

$(d)/bufio/pipe.o: $(d)/bufio/pipe.c
	$(Build_$(@D))

$(d)/bufio/drain.o: $(d)/bufio/drain.c
	$(Build_$(@D))

$(d)/libevnet.a: $(OBJS_$(d))
	$(AR) $(ARFLAGS) $@ $(OBJS_$(@D))
	$(RANLIB) $(RANLIBFLAGS) $@

all: $(d)/libevnet.a


#
# PIC Compilation Targets
#
BuildPIC_$(d)	= $(LIBTOOL) --mode=compile $(CC) -c $(CPPFLAGS_$(@D)) $(CFLAGS_$(@D)) -o $@ $^ $>

$(d)/socket.lo: $(d)/socket.c
	$(BuildPIC_$(@D))

$(d)/thread.lo: $(d)/thread.c
	$(BuildPIC_$(@D))

$(d)/lookup.lo: $(d)/lookup.c
	$(BuildPIC_$(@D))

$(d)/tls.lo: $(d)/tls.c
	$(BuildPIC_$(@D))

$(d)/bufio.lo: $(d)/bufio.c
	$(BuildPIC_$(@D))

BuildPIC_$(d)/bufio	= $(LIBTOOL) --mode=compile $(CC) -c $(CPPFLAGS_$(@D)) $(CFLAGS_$(@D)) -o $@ $^ $>

$(d)/bufio/membuf.lo: $(d)/bufio/membuf.c
	$(BuildPIC_$(@D))

$(d)/bufio/pagebuf.lo: $(d)/bufio/pagebuf.c
	$(BuildPIC_$(@D))

$(d)/bufio/socket.lo: $(d)/bufio/socket.c
	$(BuildPIC_$(@D))

$(d)/bufio/pipe.lo: $(d)/bufio/pipe.c
	$(BuildPIC_$(@D))

$(d)/bufio/drain.lo: $(d)/bufio/drain.c
	$(BuildPIC_$(@D))

$(d)/libevnet.la: $(OBJS_$(d):.o=.lo)
	$(LIBTOOL) --mode=link $(CC) -rpath $(libdir) -version-info $$(echo $(VERSION_$(@D)) | tr '.' ':') -o $@ $^ $>

pic: $(d)/libevnet.la


#
# Install targets
#
$(DESTDIR)$(libdir)/libevnet.a: $(d)/libevnet.a
	$(MKDIR) -p $(@D)
	$(INSTALL_DATA) $^ $> $@
	@if [ -f $(^:.a=.la) $(>:.a=.la) ]; then \
		$(LIBTOOL) --mode=install $(INSTALL_DATA) $(^:.a=.la) $(>:.a=.la) $(@:.a=.la); \
	fi

$(DESTDIR)$(includedir)/evnet/socket.h: $(d)/socket.h
	$(MKDIR) -p $(@D)
	$(INSTALL_DATA) $^ $> $@

$(DESTDIR)$(includedir)/evnet/thread.h: $(d)/thread.h
	$(MKDIR) -p $(@D)
	$(INSTALL_DATA) $^ $> $@

$(DESTDIR)$(includedir)/evnet/lookup.h: $(d)/lookup.h
	$(MKDIR) -p $(@D)
	$(INSTALL_DATA) $^ $> $@

$(DESTDIR)$(includedir)/evnet/tls.h: $(d)/tls.h
	$(MKDIR) -p $(@D)
	$(INSTALL_DATA) $^ $> $@

$(DESTDIR)$(includedir)/evnet/bufio.h: $(d)/bufio.h
	$(MKDIR) -p $(@D)
	$(INSTALL_DATA) $^ $> $@

$(DESTDIR)$(includedir)/evnet/bufio/drain.h: $(d)/bufio/drain.h
	$(MKDIR) -p $(@D)
	$(INSTALL_DATA) $^ $> $@

$(DESTDIR)$(includedir)/evnet/bufio/membuf.h: $(d)/bufio/membuf.h
	$(MKDIR) -p $(@D)
	$(INSTALL_DATA) $^ $> $@

$(DESTDIR)$(includedir)/evnet/bufio/pagebuf.h: $(d)/bufio/pagebuf.h
	$(MKDIR) -p $(@D)
	$(INSTALL_DATA) $^ $> $@

$(DESTDIR)$(includedir)/evnet/bufio/pipe.h: $(d)/bufio/pipe.h
	$(INSTALL_DATA) $^ $> $@

$(DESTDIR)$(includedir)/evnet/bufio/socket.h: $(d)/bufio/socket.h
	$(MKDIR) -p $(@D)
	$(INSTALL_DATA) $^ $> $@

.INTERMEDIATE: $(d)/install -levnet

$(d)/install: $(DESTDIR)$(libdir)/libevnet.a \
	 $(DESTDIR)$(includedir)/evnet/socket.h $(DESTDIR)$(includedir)/evnet/thread.h \
	 $(DESTDIR)$(includedir)/evnet/lookup.h $(DESTDIR)$(includedir)/evnet/bufio.h \
	 $(DESTDIR)$(includedir)/evnet/tls.h \
	 $(DESTDIR)$(includedir)/evnet/bufio/drain.h \
	 $(DESTDIR)$(includedir)/evnet/bufio/membuf.h \
	 $(DESTDIR)$(includedir)/evnet/bufio/pagebuf.h \
	 $(DESTDIR)$(includedir)/evnet/bufio/pipe.h \
	 $(DESTDIR)$(includedir)/evnet/bufio/socket.h

-levnet: $(d)/install

install: $(d)/install


#
# Uninstall targets
#
.PHONY: $(d)/uninstall

$(d)/uninstall:
	rm -fr $(DESTDIR)$(includedir)/evnet
	rm -f $(DESTDIR)$(libdir)/libevnet.a
	@$(LIBTOOL) --mode=uninstall rm -f $(DESTDIR)$(libdir)/libevnet.la 2>/dev/null || true

uninstall: $(d)/uninstall


#
# Clean targets
#
.PHONY: $(d)/clean

$(d)/clean:
	rm -f $(@D)/*.o $(@D)/*.a $(@D)/bufio/*.o
	@$(LIBTOOL) --mode=clean rm -f $(OBJS_$(@D):.o=.lo) $(@D)/libevnet.la 2>/dev/null || true

clean: $(d)/clean


# Non-recursive epilogue.
include $(Epilogue)

