/* ==========================================================================
 * dns.h - DNS library.
 * --------------------------------------------------------------------------
 * Copyright (c) 2007  William Ahern
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit
 * persons to whom the Software is furnished to do so, subject to the
 * following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
 * NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
 * USE OR OTHER DEALINGS IN THE SOFTWARE.
 * ==========================================================================
 */
#ifndef DNS_H
#define DNS_H

#if (__STDC_VERSION__+0) < 199901L
#error C99 mode required
#endif

#include <stdbool.h>	/* bool */

#include <limits.h>	/* CHAR_BIT */


#define DNS_NOERRNO	(&(enum dns_errno){ 0 })

enum dns_errno {
	DNS_ESUCCESS,
	DNS_ESYSTEM,
	DNS_ETRUNCATED,
	DNS_EINVALID,
	DNS_ERANGE,
}; /* enum dns_errno */

extern const char *dns_errlist[];

struct dns_options {
	int foo;
}; /* struct dns_options */

extern const struct dns_options dns_defaults;


#include "dns/inline.h"

#include "dns/record.h"
#include "dns/message.h"

#include "dns/rr/a.h"
#include "dns/rr/aaaa.h"
#include "dns/rr/mx.h"
#include "dns/rr/ns.h"
#include "dns/rr/txt.h"


#if 0
#include "dns/m/txt.h"
#include "dns/m/a.h"
#include "dns/m/aaaa.h"

#include "dns/database.h"

#include "dns/db/file.h"
#include "dns/db/udp.h"
#endif

#endif /* DNS_H */


